/***************************************************************************
 *   Copyright (C) 2007 by Saritha Kalyanam   				   *
 *   sari.kaly@gmail.com   						   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __AZUREUS_DB_H__
#define __AZUREUS_DB_H__

#include "types.h"
#include "queue.h"

#define AZUREUS_MAX_KEYS_PER_PKT    255
#define AZUREUS_MAX_VALS_PER_KEY    255
#define AZUREUS_MAX_KEY_LEN         255
#define AZUREUS_MAX_VAL_LEN         256

struct azureus_db_key {
    u8                      len;
    u8                      data[AZUREUS_MAX_KEY_LEN];
};

struct azureus_db_val {
    u16                     len;
    u8                      data[AZUREUS_MAX_VAL_LEN];
};

struct azureus_db_valset {
    u8                      n_vals;
    struct azureus_db_val   val[AZUREUS_MAX_VALS_PER_KEY];
};

struct azureus_db_item {
    struct azureus_db_key               key;
    struct azureus_db_valset            valset;
    TAILQ_ENTRY(azureus_db_item)        next;
};

#endif /* __AZUREUS_DB_H__ */
