/***************************************************************************
 *   Copyright (C) 2007 by Saritha Kalyanam                                *
 *   sari.kaly@gmail.com                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "tinydht.h"

int
main(int argc, char *argv[])
{
    int sock;
    struct sockaddr_in addr4;
    int ret;
    struct tinydht_msg_req req;
    struct tinydht_msg_rsp rsp;

    sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (sock < 0) {
        perror("socket()");
        return -1;
    }

    bzero(&addr4, sizeof(struct sockaddr_in));
    addr4.sin_family = AF_INET;
    addr4.sin_port = htons(TINYDHT_SERVICE);
    ret = inet_aton("192.168.1.104", &addr4.sin_addr);
    if (ret < 0) {
        return -1;
    }

    printf("%#x:%hu\n", addr4.sin_addr.s_addr, TINYDHT_SERVICE);

    ret = connect(sock, (struct sockaddr *)&addr4, sizeof(addr4));
    if (ret < 0) {
        perror("connect()");
        return -1;
    }

    bzero(&req, sizeof(req));
    req.action = TINYDHT_ACTION_PUT;
    strncpy(req.key, "test", MAX_KEY_LEN);
    req.key_len = htonl(strlen("test"));
    strncpy(req.val, "success", MAX_KEY_LEN);
    req.val_len = htonl(strlen("success"));

    ret = send(sock, &req, sizeof(req), 0);
    if (ret < 0 || ret != sizeof(req)) {
        perror("send()");
        return -1;
    }

    ret = recv(sock, &rsp, sizeof(rsp), 0);
    if (ret < 0 || ret != sizeof(rsp)) {
        perror("recv()");
        return -1;
    }

    bzero(&req, sizeof(req));
    req.action = TINYDHT_ACTION_PUT;
    strncpy(req.key, "test", MAX_KEY_LEN);
    req.key_len = htonl(strlen("test"));

    ret = send(sock, &req, sizeof(req), 0);
    if (ret < 0 || ret != sizeof(req)) {
        perror("send()");
        return -1;
    }

    ret = recv(sock, &rsp, sizeof(rsp), 0);
    if (ret < 0 || ret != sizeof(rsp)) {
        perror("recv()");
        return -1;
    }

    close(sock);

    return 0;
}
